﻿<%@ Control Language="C#" Inherits="System.Web.Mvc.ViewUserControl" %>
<%@ Import Namespace="HLWebOKBQueryPlugin.Models" %>
<%@ Import Namespace="HLWebOKBQueryPlugin.OKBQueryService" %>
<%@ Import Namespace="HLWebOKBQueryPlugin.ViewModels" %>
<script src="/Scripts/MicrosoftAjax.js" type="text/javascript"></script>
<script src="/Scripts/MicrosoftMvcValidation.js" type="text/javascript"></script>
<script type="text/javascript">
    function setAction(action, id) {
        document.getElementById('selectedFilter').value = id;
        document.getElementById('action').value = action;
        document.filterForm.submit();
    }
</script>

<% using (Html.BeginForm("AddFilter", "Filter", FormMethod.Post, new { Name = "filterForm" })) %>
<% {  %>
<!-- Put all into a form that calls the "AddFilter" Action-->
<%
    CombinedFilter topFilter = ((FilterModel)Model).Content;
%>
<%: Html.Hidden("selectedFilter",null, new { Id = "selectedFilter" })%>
<%: Html.Hidden("action", null, new { Id = "action" })%>
<div>
    <%
        foreach (Filter fNode in topFilter.Filters) {

            CombinedFilter currentFilter = (CombinedFilter)fNode;
            string comboboxName = FilterModel.ComboboxName + "." + currentFilter.Id;
            string hiddenName = FilterModel.ParentIdName + "." + currentFilter.Id;
    %>
    <ul style="background-color: #eeeeee;border-style:solid;border-color:#aaa;border-width:1px;padding:10px;list-style-type:none;">
        <li>
            <%: Html.Hidden(hiddenName, currentFilter.Id.ToString())%>
            <%: Html.DropDownList(comboboxName, new SelectList(((FilterModel)Model).AvailableFilterForCombobox, "FilterTypeName", "Label"))%>
            <input type="button" name="submitButton" value="+" class="hl-button-text-plus" onclick="setAction('add','<%: currentFilter.Id%>');" />
            <!-- <input type="submit" name="submitButton" value="+.<%:currentFilter.Id%>"  />-->
        </li>
        <!-- Build the selected filters. The filtesr will be stored in the session and the
Controller puts the current filters from the session into the model. Selected Filters
will be iterated. -->
        <% if (currentFilter.Filters != null) {

               foreach (Filter f in currentFilter.Filters) {
                   if (f != null) {  %>
        <li style="background-color:#FFF380;padding:5px;margin:5px;">
            <%
           

                if ("StringComparisonFilter".Equals(f.GetType().Name)) { 
            %>
            <% StringComparisonFilter filter = ((StringComparisonFilter)f); %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, (filter.Value))%>
            <% }
                                else if ("NameStringComparisonFilter".Equals(f.GetType().Name)) { %>
            <% NameStringComparisonFilter filter = ((NameStringComparisonFilter)f); %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }
                                else if ("StringComparisonAvailableValuesFilter".Equals(f.GetType().Name)) { %>
            <% StringComparisonAvailableValuesFilter filter = ((StringComparisonAvailableValuesFilter)f); %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueTextbox, new SelectList(filter.AvailableValues, filter.Value))%>
            <% }
                                else if ("NameEqualityComparisonByteArrayFilter".Equals(f.GetType().Name)) { %>
            <% NameEqualityComparisonByteArrayFilter filter = ((NameEqualityComparisonByteArrayFilter)f); %>
            <%: Html.Label(filter.Label)%>
            <%: Html.Label("not supported")%>
            <% }
                                else if ("NameEqualityComparisonBoolFilter".Equals(f.GetType().Name)) { %>
            <% NameEqualityComparisonBoolFilter filter = ((NameEqualityComparisonBoolFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.BoolComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(((FilterModel)Model).BoolStates, filter.Value))%>
            <% }
                                else if ("NameOrdinalComparisonIntFilter".Equals(f.GetType().Name)) { %>
            <% NameOrdinalComparisonIntFilter filter = ((NameOrdinalComparisonIntFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }
                                else if ("NameStringComparisonAvailableValuesFilter".Equals(f.GetType().Name)) { %>
            <% NameStringComparisonAvailableValuesFilter filter = ((NameStringComparisonAvailableValuesFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.StringComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ValueDropDownList, new SelectList(filter.AvailableValues, filter.Value))%>
            <% }
                                else if ("NameOrdinalComparisonDoubleFilter".Equals(f.GetType().Name)) { %>
            <% NameOrdinalComparisonDoubleFilter filter = ((NameOrdinalComparisonDoubleFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }
                                else if ("NameOrdinalComparisonFloatFilter".Equals(f.GetType().Name)) { %>
            <% NameOrdinalComparisonFloatFilter filter = ((NameOrdinalComparisonFloatFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }
                                else if ("NameOrdinalComparisonLongFilter".Equals(f.GetType().Name)) { %>
            <% NameOrdinalComparisonLongFilter filter = ((NameOrdinalComparisonLongFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }
                                else if ("OrdinalComparisonDateTimeFilter".Equals(f.GetType().Name)) { %>
            <% OrdinalComparisonDateTimeFilter filter = ((OrdinalComparisonDateTimeFilter)f);   %>
            <%: Html.Label(filter.Label)%>
            <%: Html.DropDownList(f.Id + "." + FilterModel.ComparisonDropDownList, new SelectList(FilterModel.OrdinalComparisons, "Value", "Text", (int)filter.Comparison))%>
            <%: Html.TextBox(f.Id + "." + FilterModel.ValueTextbox, filter.Value)%>
            <% }                 
                  
            %>
            <!-- <input type="submit" name="submitButton" value="-.<%:f.Id%>"  class="hl-icon-delete"  style="text-indent:-999em;"  />
       -->
            <input type="button" name="submitButton" value="-" class="hl-icon-delete" onclick="setAction('delete','<%: f.Id%>');" />
            <% } // if%>
        </li>
        <% } // inner foreach %>
    </ul>
     <% } // if%>
    <% 
           }// foreach
    %>
    <a    class="hl-button-text-plus" onclick="setAction('or','');" >OR Filter</a>
    <a   class="hl-icon-refresh"  onclick="setAction('runs','');" >Refresh</a>
    <%
        }   // form 
    %>
</div>
